#include "4inarow.h"

void initialize(fourinarow *four_game)
{
  int count1,count2;
  four_game->nmoves=0;
  for(count2=0;count2<NCOLUMNS;count2++)
  {
    four_game->pieces_in_a_column[count2]=0;
    for(count1=0;count1<NROWS;count1++)
    {
      four_game->matrix[count1][count2]=BLANK;
    }
  }
}

void print_game (fourinarow *four_game)
{
  int count1,count2;
  system("clear");
  printf("\n\n\n");
  for(count1=NROWS-1;count1>=0;count1--)
  {
    printf("\n\t\t\t|");
    for(count2=0;count2<NCOLUMNS;count2++)
    {
      printf(" %c |",four_game->matrix[count1][count2]);
    }
    printf("\n\t\t\t+");
    for(count2=0;count2<NCOLUMNS;count2++)
    {
      printf("---+");
    }
  }
  printf("\n\t\t\t");
  for(count2=0;count2<NCOLUMNS;count2++)
  {
    printf("  %d ",count2+1);
  }
  printf("\n");
}

int insert(fourinarow *four_game,int colonna,char colore)
{
  if(four_game->pieces_in_a_column[colonna]<NROWS)
  {
    four_game->nmoves++;
    four_game->matrix[four_game->pieces_in_a_column[colonna]][colonna]=colore;
    four_game->pieces_in_a_column[colonna]++;
    return(TRUE);
  }
  else return(FALSE);
}

int insert_column(fourinarow *four_game,char name[])
{
  char input[MAXC]="";
  int bool=FALSE,answer;
  while(bool!=TRUE)
  {
    printf("\n%s: ",name);
    scanf("%s",input);
    switch(input[0])
    {
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      {
        answer=input[0] - '0' - 1;
        if(four_game->pieces_in_a_column[answer]<NROWS)
        {
          bool=TRUE;
          break;
        }
        printf("\nCOLUMN %d IS FULL",answer+1);
        break;
      }
      default: printf("\nErrore di digitazione!"); break;
    }
  }
  return(answer);
}
 
