#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define FOURINAROW 4
#define NCOLUMNS 7
#define NROWS 6
#define NMOVES NCOLUMNS*NROWS
#define BLANK ' '
#define RED 'X'
#define YELLOW '0'
#define MAXC 10
#define TRUE 1
#define FALSE 0

typedef struct data
{
  int nmoves;
  int pieces_in_a_column[NCOLUMNS];
  char matrix[NROWS][NCOLUMNS];
} fourinarow;

void initialize(fourinarow *four_game);
void print_game(fourinarow *four_game);
int insert(fourinarow *four_game,int column,char color);
int checking(fourinarow *four_game,int col,char color);
int insert_column(fourinarow *four_game,char name[]);
